<template>
	<view class="pages">
		<view class="status-bar">
			<view class="status-bar-item" :class="params.orderStatus != 1&&params.orderStatus != 5&&params.orderStatus != 2?'active':''" @click="changestatus()">全部</view>
			<view class="status-bar-item" :class="params.orderStatus == 1?'active':''" @click="changestatus(1)">未支付</view>
			<view class="status-bar-item" :class="params.orderStatus == 2?'active':''" @click="changestatus(2)">已支付</view>
			<!-- <view class="status-bar-item" :class="params.orderStatus == 5?'active':''" @click="changestatus(5)">已完成</view> -->
		</view>
		<mescroll-body class="" ref="mescrollRef" @init="mescrollInit" @down="downCallback" @up="upCallback" :down="downOption" :up="upOption">
			<view class="orders">
				<view v-for="(item,index) in orderlist" :key="index" class="order-item" @click="goOrderDetails(item.guid)">
					<view class="order-info">
						<view class="order-info-text">
							<view class="order-info-text-item">订单编号：{{item.orderNo}}</view>
							<view class="order-info-text-item">订单时间：{{item.createTime}}</view>
						</view>
						<view class="order-info-status">
							<!-- <view class="status" v-if="item.orderStatus == 1" @click="cancelOrder(item)">取消订单</view> -->
							<!-- <view class="status" v-if="item.orderStatus == 1">待支付</view> -->
							<view class="status" v-if="item.orderStatus == 2">已支付</view>
							<view class="status" v-if="item.orderStatus == 3">未审核</view>
							<view class="status" v-if="item.orderStatus == 4">已审核</view>
							<view class="status" v-if="item.orderStatus == 5">已完成</view>							
						</view>
					</view>
					<!-- order-info end -->
					<view class="order-product">
						<image :src="item.goodsOrderDetailForm[0].goodsImages" class="order-product-img" mode="scaleToFill"></image>
						<view class="order-product-text">
							<view class="order-product-til">
								{{item.goodsOrderDetailForm.length}}个碳汇产品，共计{{item.orderCarbonAmount}}kg碳汇量
							</view>
							<view class="order-product-amount">
								<text class="rmb">¥</text>
								<text class="amount">{{item.orderAmount}}</text>
							</view>
							<view class="order-product-carbon">共{{item.orderCarbonAmount}}kg碳汇量</view>
							<view class="order-btn topay" v-if="item.orderStatus == 1&&item.state==1" @click.stop="pay(item)">立即支付</view>
							<view class="order-btn" v-if="item.orderStatus == 2" @click.stop="$api.href('/pages/usercenter/certificateList/certificate?id='+item.id)">查看证书</view>	
							<view class="order-btn" v-if="item.orderStatus == 5" @click.stop="$api.href('/pages/usercenter/certificateList/certificate?id='+item.id)">查看证书</view>							
						</view>
					</view>
				</view>
				<!-- order-item end -->
			</view>
			<!-- order end -->
		</mescroll-body>
		<uni-popup ref="popup" type="dialog">
		    <uni-popup-dialog type="info"  :content="popupContent" :duration="2000" :before-close="true" @close="closepopup" @confirm="confirmpopup"></uni-popup-dialog>
		</uni-popup>
	</view>
</template>

<script>
	// 引入mescroll-mixins.js
	import MescrollMixin from "@/components/mescroll-uni/mescroll-mixins.js";	
	// 引入mescroll-body组件 (如已在main.js注册全局组件,则省略此步骤)
	import MescrollBody from "@/components/mescroll-uni/mescroll-body.vue"; // 注意.vue后缀不能省
	
	import uniPopup from '@/components/uni-popup/uni-popup.vue';
	import uniPopupDialog from '@/components/uni-popup/uni-popup-dialog.vue';
	export default {
		mixins: [MescrollMixin], // 使用mixin
		components: {
			MescrollBody,
			uniPopup,
			uniPopupDialog,
		},
		data() {
			return {
				mescroll: null, // mescroll实例对象 (此行可删,mixins已默认)
				// 下拉刷新的配置(可选, 绝大部分情况无需配置)
				downOption: { 
					// ...
				},
				// 上拉加载的配置(可选, 绝大部分情况无需配置)
				upOption: {
					page: {
						size: 10 // 每页数据的数量,默认10
					},
					noMoreSize: 3, // 配置列表的总数量要大于等于5条才显示'-- END --'的提示
					empty: {
						tip: '暂无相关数据'
					}
				},
				tokenhead:'Bearer',
				token:'',
				params:{
					orderStatus:'',
					// tokenhead:'',
					// token:'',
				},
				orderlist:[],
				cancelId:null,
				receiveId:null,
				popupContent:'',
				popupType:'',
				
			}
		},
		onShow() {
			this.token = this.$store.state.token;
		},
		onLoad() {
		},
		methods: {
			/*mescroll组件初始化的回调,可获取到mescroll对象 (此处可删,mixins已默认)*/
			mescrollInit(mescroll) {
				this.mescroll = mescroll;
			},
			/*下拉刷新的回调, 有三种处理方式:*/
			downCallback(){			
				// 第2种: 下拉刷新和上拉加载调同样的接口, 那么不用第1种方式, 直接mescroll.resetUpScroll()即可
				this.mescroll.resetUpScroll(); // 重置列表为第一页 (自动执行 page.num=1, 再触发upCallback方法 )
			},
			getList(page,token){
				this.$api.http.post(this.config.apiBaseurl + '/carbon-h5/wap/order/searchByPage',this.params,{
					header: {
					Accept:'application/json',
					Authorization: 'Bearer '+ token, //注意Bearer后面有一空格
				},
				}).then(data => {
					// console.log(data);
					// 接口返回的当前页数据列表 (数组)
					let curPageData = data.data.retBody; 
					// console.log('curPageData',curPageData);
					// 接口返回的当前页数据长度 (如列表有26个数据,当前页返回8个,则curPageLen=8)
					let curPageLen = curPageData.length; 
					// 接口返回的总页数 (如列表有26个数据,每页10条,共3页; 则totalPage=3)
					// let totalPage = data.xxx; 
					// 接口返回的总数据量(如列表有26个数据,每页10条,共3页; 则totalSize=26)
					let totalSize = data.data.retHead.total; 
					// this.mescrollList = curPageData;
					// 接口返回的是否有下一页 (true/false)
					// let hasNext = data.xxx; 
					
					//设置列表数据
					if(page.num == 1) this.orderlist = []; //如果是第一页需手动置空列表
					this.orderlist = this.orderlist.concat(curPageData); //追加新数据
					// console.log('page.num',page.num);
					console.log('this.orderlist',JSON.parse(JSON.stringify(this.orderlist)));
					
					//方法二(推荐): 后台接口有返回列表的总数据量 totalSize
					this.mescroll.endBySize(curPageLen, totalSize); 
							
					// setTimeout(()=>{
					// 	this.mescroll.endSuccess(curPageLen)
					// },20)
				
				}).catch(err => {
					this.mescroll.endErr()
					console.log(err)
				
				});
				
			},
			/*上拉加载的回调*/
			upCallback(page) {
				let self = this;
				let pageNum = page.num; // 页码, 默认从1开始
				let pageSize = page.size; // 页长, 默认每页10条
				this.params = Object.assign(this.params,{pageNum:pageNum,pageSize:pageSize});
				this.$api.http.post(this.config.apiBaseurl + '/carbon-h5/wap/order/searchByPage',this.params,{
					header: {
					Accept:'application/json',
					Authorization: 'Bearer '+ this.token, //注意Bearer后面有一空格
				},
				}).then(data => {
					// console.log(data);
					// 接口返回的当前页数据列表 (数组)
					let curPageData = data.data.retBody; 
					// console.log('curPageData',curPageData);
					// 接口返回的当前页数据长度 (如列表有26个数据,当前页返回8个,则curPageLen=8)
					let curPageLen = curPageData.length; 
					// 接口返回的总页数 (如列表有26个数据,每页10条,共3页; 则totalPage=3)
					// let totalPage = data.xxx; 
					// 接口返回的总数据量(如列表有26个数据,每页10条,共3页; 则totalSize=26)
					let totalSize = data.data.retHead.total; 
					// this.mescrollList = curPageData;
					// 接口返回的是否有下一页 (true/false)
					// let hasNext = data.xxx; 
					
					//设置列表数据
					if(page.num == 1) this.orderlist = []; //如果是第一页需手动置空列表
					this.orderlist = this.orderlist.concat(curPageData); //追加新数据
					// console.log('page.num',page.num);
					console.log('this.orderlist',JSON.parse(JSON.stringify(this.orderlist)));
					
					//方法二(推荐): 后台接口有返回列表的总数据量 totalSize
					this.mescroll.endBySize(curPageLen, totalSize); 
							
					// setTimeout(()=>{
					// 	this.mescroll.endSuccess(curPageLen)
					// },20)
				
				}).catch(err => {
					this.mescroll.endErr()
					console.log(err)
				
				});
			},
			//删除订单
			delOrder(item){
				
			},
			cancelOrder(item){
				console.log(JSON.parse(JSON.stringify(item)));
				this.cancelId = item.id;
				this.$refs.popup.open();
				this.popupContent = '确认取消此订单吗?';
				this.popupType = 'cancel';				
			},
			received(item){
				this.receiveId = item.id;
				this.$refs.popup.open();
				this.popupContent = '确认收货?';
				this.popupType = 'received';
			},
			closepopup(done){
				done()
			},
			confirmpopup(done,value){
				if(this.popupType == 'cancel'){
					this.$api.http.post(this.config.apiBaseurl + '/order/cancelUserOrder/?orderId='+this.cancelId,{},{
						header: {
						Accept:'application/json',
						Authorization: 'Bearer '+ this.token, //注意Bearer后面有一空格
					},
					}).then(res => {
						this.downCallback();
						// console.log('res',res)
					}).catch(err =>{
						console.log('err',err)
					});
				}else if(this.popupType == 'received'){
					this.$api.http.post(this.config.apiBaseurl + '/order/confirmReceiveOrder/?orderId='+this.receiveId,{},{
						header: {
						Accept:'application/json',
						Authorization: 'Bearer '+ this.token, //注意Bearer后面有一空格
					},
					}).then(res => {
						this.downCallback();
						// console.log('res',res)
					}).catch(err =>{
						console.log('err',err)
					});
				}
				
				done()
			},
			changestatus(status){
				this.params.orderStatus  = status;
				this.downCallback();
			},
			goOrderDetails(id){
				console.log(id)
				uni.navigateTo({
					url: './orderdetails/orderdetails?orderid=' + id,
				});
			},
			pay(item){
				let self = this;
				console.log('pay item',item);
				let userInfo = uni.getStorageSync("userInfo");
				console.log('userInfo',userInfo);
				// return
				let params = {
					orderId:item.guid,
					// payType:item.payType,
					openid:userInfo.wxId,
					"tradeType":"test"
				};
				this.$api.http.post(this.config.apiBaseurl + "/carbon-h5/wechat/pay",params,{
					header: {
					Accept:'application/json',
					Authorization: 'Bearer '+ this.token, //注意Bearer后面有一空格
				},
				}).then(res=>{
					uni.requestPayment({
					    provider: 'wxpay',
					    timeStamp:res.data.retBody.timeStamp,
					    nonceStr: res.data.retBody.nonceStr,
					    package: res.data.retBody.packageValue,
					    signType: 'MD5',
					    paySign: res.data.retBody.paySign,
					    success: function (res) {
							self.downCallback();
					        console.log('success:' + JSON.stringify(res));
					    },
					    fail: function (err) {
					        console.log('fail:' + JSON.stringify(err));
					    }
					});
				}).catch( err =>{
					console.log('pay err',err)
				})

			},

		}
	}
</script>

<style>
@import url("./orderList.css");
</style>
